package Format;

my $pkg="Format";

use strict;
use My;
use Info;
use Class::Date qw(date);


#======== Hlavni formatovaci funkce - obecne
#- formatovani cisla
sub formatNumber {
   my ($pkg_p, $number,$prefix,$thous,$dec,$postfix)=@_;
   my ($numberT,$numberD);
   if(!defined($dec)) {
      ($numberT,$numberD)=split(/\./,$number);
      $dec=length($numberD);
   }
   elsif($dec>=0) {
      ($numberT,$numberD)=split(/\./,sprintf("%.${dec}f",$number));
   }
   else {
      ($numberT,$numberD)=split(/\./,sprintf("%.0f", $number * (10**$dec) ) );
   }
   my $sign;
   if($numberT<0) {
      $sign="-";
      $numberT*=-1;
   }
   else {
      $sign="";
   }
   if($thous and (my $lenT=length($numberT))>3) {
      my $tsep;
      if(get_env("lang") eq "en") {
         $tsep=",";
      }
      else {
         $tsep=" ";
      }
      if($lenT<7) {
         $numberT=~s/^(\d+)(\d{3})$/${1}${tsep}${2}/;
      }
      elsif($lenT<10) {
         $numberT=~s/^(\d+)(\d{3})(\d{3})$/${1}${tsep}${2}${tsep}${3}/;
      }
      else {
         $numberT=~s/^(\d+)(\d{3})(\d{3})(\d{3})$/${1}${tsep}${2}${tsep}${3}${tsep}${4}/;
      }
   }
   if($dec>0) {
      $number=$sign.$numberT.".".$numberD;
   }
   else {
      $number=$sign.$numberT;
   }
   return $prefix . $number . $postfix;
}

#- funkce prevadejici retezec pro formatovani cisla uzivany v XML na retezec uzivany funkci perlu
sub formatNumber_covert {
   my ($pkg_p, $format)=@_;
   my ($prefix,$thous,$dec,$postfix);
   $format=~/^([^\#0]*)([\#0\,]*)\.{0,1}([\#0]*)([^\#0]*)$/;
   $prefix=$1; $prefix=~s/\\\%/\%/g;
   my $thoustext=$2;
   my $dectext=$3;
   $postfix=$4; $postfix=~s/\\\%/\%/g;
   # tisice (poznamka: $thous==1 - oddelovat tisice; $thous==0 - neoddelovat tisice)
   my $thouslength;
   if($thoustext=~/^.*\,([\#0]*)$/) {
      $thouslength=length($1);
   }
   if(defined($thouslength)) {
      $thous=1;
   }
   else {
      $thous=0;
   }
   # desetiny
   if(length($dectext)) {
      $dec=length($dectext);
   }
   elsif(defined($thouslength)) {
      $dec=$thouslength-3;
   }
   return ($prefix,$thous,$dec,$postfix);
}

#- formatovani data
sub formatDate {
   my ($pkg_p, $date,$format)=@_;
   $date=~s/T/ /;
   my $datestr;
   if($date=~/^0000-00-00/) {
      $datestr="-";
   }
   else {
      $datestr=date($date)->strftime($format);
   }
   return $datestr;
}

#- funkce prevadejici retezec pro formatovani data ci casu uzivany v XML na retezec uzivany funkci perlu
sub formatDate_covert {
   my ($pkg_p, $format)=@_;
   $format=~s/yyyy/\%Y/g;
   $format=~s/yy/\%y/g;
   $format=~s/MMMM/\%B/g;
   $format=~s/MMM/\%b/g;
   $format=~s/MM/\%m/g;
   $format=~s/M/\%m/g; # tohle neni uplne ok, jelikoz %m vraci 01 az 12 a ne 1 az 12, coz bych chtel
   $format=~s/dddd/\%A/g;
   $format=~s/ddd/\%a/g;
   $format=~s/dd/\%D/g;
   $format=~s/d/\%e/g;
   $format=~s/\%D/\%d/g; # opravicka predchoziho nahrazeni
   $format=~s/hh/\%H/g;
   $format=~s/h/\%k/g;
   $format=~s/mm/\%M/g; # ke kolizi s %m by nemelo dojit
   $format=~s/ss/\%S/g;
   return ($format);
}


#======== Hlavni formatovaci funkce - konkretni
#- formatovani zak
sub zak {
   my ($pkg_p,$hodnota,$encode_entities)=@_;
   $hodnota=~s/ //g;
   if(length($hodnota)) {
      if($encode_entities!=1) {
         $hodnota=substr($hodnota,0,1) . " " . substr($hodnota,1,3) . " " . substr($hodnota,4,4) . " " . substr($hodnota,8);
      }
      else {
         $hodnota=encode_entities(substr($hodnota,0,1)) . "&#160;" . encode_entities(substr($hodnota,1,3)) . "&#160;" . encode_entities(substr($hodnota,4,4)) . "&#160;" . encode_entities(substr($hodnota,8));
      }
   }
   return $hodnota;
}

#- formatovani nar
sub nar {
   my ($pkg_p,$hodnota,$encode_entities)=@_;
   $hodnota=~s/ //g;
   if(length($hodnota)) {
      if($encode_entities!=1) {
         $hodnota=substr($hodnota,0,3) . " " . substr($hodnota,3,4) . " " . substr($hodnota,7);
      }
      else {
         $hodnota=encode_entities(substr($hodnota,0,3)) . "&#160;" . encode_entities(substr($hodnota,3,4)) . "&#160;" . encode_entities(substr($hodnota,7));
      }
   }
   return $hodnota;
}

#======== Formatovaci funkce specialne urcene pro nejake prvky
#- vraci popisek znaku neuplnosti, formatovany pro atribut title
sub title_znupl {
   my ($pkg_p, $znupl)=@_;
   my $title;
   my $refznupl=Info->znupl($znupl);
   foreach my $znuplp (sort keys %{$refznupl}) {
      $title.= $znuplp ." - " . $$refznupl{$znuplp};
      $title.= "\n";
   }
   return $title;
}


#======== Funkce vracejici seznamy pro padaci menu
#- vraci seznam organizaci
sub selectmenu_org {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Org.org as value,
         concat(Org.org, " - ", Org.nazev) as print
      from
         Spolecnost.Org
      order by
         Org.org asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam vyrobnich typu stredisek
sub selectmenu_vyrtyp {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Vyrtyp.vyrtyp as value,
         concat(Vyrtyp.vyrtyp, " - ", Vyrtyp.nazev) as print
      from
         Spolecnost.Vyrtyp
      order by
         Vyrtyp.vyrtyp asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam charakteristi
sub selectmenu_ch {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Charakteristiky.ch as value,
         concat(Charakteristiky.ch, " - ", substring(Charakteristiky.nazev,1,50)) as print
      from
         Zakazky.Charakteristiky
      order by
         Charakteristiky.ch asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam mernych jednotek
sub selectmenu_mj {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Mj.mj as value,
         substring(Mj.nazev,1,50) as print
      from
         Zakazky.Mj
      order by
         Mj.mj asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam DM
sub selectmenu_dm {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         DruhyMezd.dm as value,
         concat(DruhyMezd.dm, " - ", DruhyMezd.nazev) as print
      from
         Spolecnost.DruhyMezd
      where
         DruhyMezd.nabizet=?
      order by
         DruhyMezd.dm asc
   });
   $sth->execute("0");
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam moznych typu zamestnani
sub selectmenu_typzam {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Typzam.typzam as value,
         concat(Typzam.typzam, " - ", Typzam.nazev) as print
      from
         Zamestnanci.Typzam
      order by
         Typzam.typzam asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam Trid
sub selectmenu_tt {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Sazebnik.tt as value,
         Sazebnik.tt as print
      from
         Spolecnost.Sazebnik
      where
         Sazebnik.platod<=? and
         Sazebnik.platdo>=?
      order by
         Sazebnik.tt asc
   });
   $sth->execute(get_env("datum"),get_env("datum"));
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam moznych stavu zamestnani
sub selectmenu_stavzam {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Stavzam.stavzam as value,
         concat(Stavzam.stavzam, " - ", Stavzam.nazev) as print
      from
         Zamestnanci.Stavzam
      order by
         Stavzam.stavzam asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam skladu - v uvahu beru i org i datum platnosti
sub selectmenu_sklady_org {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Sklady.supstr,
         Sklady.sklad as value,
         concat(Sklady.sklad, " - ", Sklady.nazev) as print
      from
         Spolecnost.Sklady
      where
         Sklady.platod<=? and
         Sklady.platdo>=?
      order by
         Sklady.sklad asc
   });
   $sth->execute(get_env("datum"),get_env("datum"));
   while(my $ref=$sth->fetchrow_hashref) {
      my $info_str=Info->str($$ref{supstr});
      if($$info_str{org} eq get_env("org")) {
         push(@selectmenu, [$$ref{value}, $$ref{print}]);
      }
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam se znakem prijmu
sub selectmenu_znprij {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Znprij.znprij as value,
         concat(Znprij.znprij, " - ", Znprij.nazev) as print
      from
         Material.Znprij
      order by
         Znprij.znprij asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam druhu uhrad
sub selectmenu_typuhrady {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Typuhrady.typuhrady as value,
         concat(Typuhrady.typuhrady, " - ", Typuhrady.nazev) as print
      from
         Obchod.Typuhrady
      order by
         Typuhrady.typuhrady asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam druhu dopravy
sub selectmenu_typdopravy {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Typdopravy.typdopravy as value,
         concat(Typdopravy.typdopravy, " - ", Typdopravy.nazev) as print
      from
         Obchod.Typdopravy
      order by
         Typdopravy.typdopravy asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam forem objednavek
sub selectmenu_formaobj {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Formaobj.formaobj as value,
         concat(Formaobj.formaobj, " - ", Formaobj.nazev) as print
      from
         Obchod.Formaobj
      order by
         Formaobj.formaobj asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam druhu popisu operaci
sub selectmenu_prilohy_operace_druhy {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Prilohy_operace_druhy.druh as value,
         Prilohy_operace_druhy.nazev as print
      from
         Vyroba_priprava.Prilohy_operace_druhy
      where
         Prilohy_operace_druhy.ind="0"
      order by
         Prilohy_operace_druhy.druh asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam indikaci pro kusovnik
sub selectmenu_ind_kusovnik {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Ind_Kusovnik.ind as value,
         concat(Ind_Kusovnik.ind, " - ", Ind_Kusovnik.nazev) as print
      from
         Zakazky.Ind_Kusovnik
      order by
         Ind_Kusovnik.ind asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam indikaci pro vykonovou normu
sub selectmenu_ind_vykon_norma {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Ind_Vykon_norma.ind as value,
         concat(Ind_Vykon_norma.ind, " - ", Ind_Vykon_norma.nazev) as print
      from
         Vyroba_priprava.Ind_Vykon_norma
      order by
         Ind_Vykon_norma.ind asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam indikaci pro normu naradi
sub selectmenu_ind_naradi_norma {
   my @selectmenu;
   my $dbh=My->dbh;
   my $sth=$dbh->prepare(q{
      select
         Ind_Naradi_norma.ind as value,
         concat(Ind_Naradi_norma.ind, " - ", Ind_Naradi_norma.nazev) as print
      from
         Vyroba_priprava.Ind_Naradi_norma
      order by
         Ind_Naradi_norma.ind asc
   });
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

#- vraci seznam indikaci pro materialovou normu na operaci 000
sub selectmenu_ind_material_norma_000 {
   $pkg->selectmenu_ind_material_norma(1);
}

#- vraci seznam indikaci pro materialovou normu
sub selectmenu_ind_material_norma {
   my ($pkg_p, $oper000)=@_;
   my @selectmenu;
   my $dbh=My->dbh;
   my $dotaz;
   $dotaz.=q{
      select
         Ind_Material_norma.ind as value,
         concat(Ind_Material_norma.ind, " - ", Ind_Material_norma.nazev) as print
      from
         Vyroba_priprava.Ind_Material_norma

   };
   if($oper000) {
      $dotaz.=q{
         where
            Ind_Material_norma.ind<="1"
      };
   }
   else {
      $dotaz.=q{
         where
            Ind_Material_norma.ind>"1"
      };
   }
   $dotaz.=q{
      order by
         Ind_Material_norma.ind asc
   };
   my $sth=$dbh->prepare($dotaz);
   $sth->execute;
   while(my $ref=$sth->fetchrow_hashref) {
      push(@selectmenu, [$$ref{value}, $$ref{print}]);
   }
   $sth->finish;
   return @selectmenu;
}

return 1;

