package Inventura;

my $pkg="Inventura";

use strict;
use lib ("/home/web-mycompany/www/lib");
use My;
use Info;

my $dbh=My->dbh;

# vraci kmint a kmstr u prvniho kmint zakazky vyssi (pozn nahodne nejake zakazky vyssi)
sub kmstr_zakv {
   my ($pkg_p, $zak)=@_;
   # pomocny dotaz pro zjistovani zakv
   my $sth_zakv=$dbh->prepare(q{
      select
         Kusovnik.zakv
      from
         Zakazky.Kusovnik
      where
         Kusovnik.zakn=? and
         Kusovnik.platod<=? and
         Kusovnik.platdo>=?
      limit
         1
   });
   # pomocny dotaz pro zjistovani strprej u kmint 999 (z normativu zakv)
   my $sth_zakvnorm=$dbh->prepare(q{
      select
         Normativy.kmstr
      from
         Vyroba_planovani.Normativy
      where
         Normativy.org=? and
         Normativy.zak=? and
         Normativy.platod<=? and
         Normativy.platdo>=?
      order by
         Normativy.kmint asc
      limit
         1
   });
   $sth_zakv->execute($zak,get_env("datum"),get_env("datum"));
   my $ref_zakv=$sth_zakv->fetchrow_hashref;
   $sth_zakv->finish;
   $sth_zakvnorm->execute(get_env("org"),$$ref_zakv{zakv},get_env("datum"),get_env("datum"));
   my $ref_zakvnorm=$sth_zakvnorm->fetchrow_hashref;
   $sth_zakvnorm->finish;
   return $$ref_zakvnorm{kmstr};
}

#- dohledani nekterych udaju z Normativu
sub kmint_prejstr {
   my ($pkg_p, $zak,$oper)=@_;
   my ($kmint,$prejstr);
   # operace neni 999
   if($oper ne "999") {
      # nalezeni kmint na kterem je oper
      my $sth=$dbh->prepare(q{
         select
            Normativy.kmint
         from
            Vyroba_planovani.Normativy
         where
            Normativy.org=? and
            Normativy.zak=? and
            Normativy.platod<=? and
            Normativy.platdo>=? and
            Normativy.odoper<=? and
            Normativy.dooper>=?
      });
      $sth->execute(get_env("org"),$zak,get_env("datum"),get_env("datum"),$oper,$oper);
      my $ref=$sth->fetchrow_hashref;
      $sth->finish;
      my $kmint_pom=$$ref{kmint};
      # zjisteni vyssiho kmint nez je nalezeny
      my $sth=$dbh->prepare(q{
         select
            Normativy.kmint,
            Normativy.kmstr
         from
            Vyroba_planovani.Normativy
         where
            Normativy.org=? and
            Normativy.zak=? and
            Normativy.kmint>? and
            Normativy.platod<=? and
            Normativy.platdo>=?
         limit
            1
      });
      $sth->execute(get_env("org"),$zak,$kmint_pom,get_env("datum"),get_env("datum"));
      my $ref=$sth->fetchrow_hashref;
      $sth->finish;
      ($kmint,$prejstr)=($$ref{kmint},$$ref{kmstr});
   }
   # oper je 999
   else {
      ($kmint,$prejstr)=("999",$pkg->kmstr_zakv($zak));
   }
   # pokud jsem nic nenalezl
   if(!length($kmint)) {
      ($kmint,$prejstr)=("999","");
   }
   return ($kmint,"$prejstr");
}

#- fce vraci jaky ma byt kmint a oper u zadane zak na montaznich dilnach
sub kmint_oper_mon {
   my ($pkg_p, $zak)=@_;
   my ($kmint,$oper);
   my $info_zak=Info->zak($zak);
   if($$info_zak{ch} eq "01" or $$info_zak{ch} eq "31" or $$info_zak{ch} eq "51") { # "vyrobni" zakazky na kterych neco montaz dela - treba nejaky drat, ktery ohyba
      # mrkni jake je cislo prvniho kmint do normativu
      my $sth_norm=$dbh->prepare(q{
         select
            Normativy.kmint
         from
            Vyroba_planovani.Normativy
         where
            Normativy.org=? and
            Normativy.zak=? and
            Normativy.platod<=? and
            Normativy.platdo>=?
         order by
            Normativy.kmint asc
         limit
            1
      });
      $sth_norm->execute(get_env("org"),$zak,get_env("datum"),get_env("datum"));
      my $ref_norm=$sth_norm->fetchrow_hashref;
      $sth_norm->finish;
      $kmint=$$ref_norm{kmint};
      if(length($kmint)==0) {
         $kmint="010"; ## k tomuhle by nemelo dochazet => tyhle zakazky by mely mit normativy
      }
      $oper="000";
   }
   else {
      $kmint="999";
      $oper="999";
   }
   return ($kmint,$oper);
}

return 1;

