package Vyroba;

my $pkg="Vyroba";

use strict;
use lib ("/home/web-mycompany/www/lib");
use My;
use Info;
use Spolecnost;


#==== Globalni promena tohohle balicku
my $dbh=My->dbh;
# priprava dotazu vracejiciho normativ
my $sth=$dbh->prepare(q{
   select
      Normativy.*
   from
      Vyroba_planovani.Normativy
   where
      Normativy.org=? and
      Normativy.zak=? and
      Normativy.platod<=? and
      Normativy.platdo>=?
   order by
      Normativy.kmint asc
});


#==== fce vraci Pocitacove normativy vyroby - tedy normativy upravene, aby se snimi lepe pracovalo v programech
sub normativy {
   my ($pkg_p, $ref_zak, $dokmint,$dostr)=@_;
   my $normativyp;
   my @str_rv=Spolecnost->seznam_str("sklrv");
   if($$ref_zak{kmorg} eq get_env("org") or $$ref_zak{kmorg} eq "0") {
      #= umely kmint 000 odpovidajici materialu - kdyz je v mat.norme na operaci 000 zaznam
      my ($kmstrmat,$mat_info)=$pkg->dodstr_mat($$ref_zak{zak});
      if(defined($kmstrmat)) {
         my $refp;
         $$refp{zak}=$$ref_zak{zak};
         $$refp{kmint}="000";
         $$refp{kmstr}=$kmstrmat;
         $$refp{odoper}="000";
         $$refp{dooper}="000";
         $$refp{dodstr}=undef;
         $$refp{prejstr}=undef;
         $$refp{dav}=0;
         $$refp{pd}=0;
         $$refp{proczm}=0;
         $$refp{ekdav}=0;
         $$refp{umely}=1;
         push(@{$normativyp},$refp);
      }
      if($$ref_zak{kmorg} ne "0") {
         #= kmint zapsane v normativech (+ upravicka normativu, aby i sklad rv mel svuj kmint)
         my @str_hv=Spolecnost->seznam_str("sklhs");
         $sth->execute(get_env("org"),$$ref_zak{zak},get_env("datum"),get_env("datum"));
         while(my $ref=$sth->fetchrow_hashref) {
            my $refp=$$normativyp[-1];
            $$refp{prejstr}=$$ref{kmstr};
            # oprava udaju na predtim vlozenem kmint pro sklad rv
            if($$refp{umely}) {
               if(!defined($$refp{kmint})) {
                  $$refp{kmint}=$$ref{kmint};
               }
               $$refp{dav}=$$ref{dav};
               $$refp{ekdav}=$$ref{ekdav};
            }
            $$ref{dodstr}=$$refp{kmstr};
            push(@{$normativyp},$ref);
            # pokud prejstr je stredisko rv, tak zde vytvorim dalsi umely kmint
            if(grep(/^\Q$$ref{prejstr}\E$/,@str_rv)) {
               my $refp;
               %{$refp}=%{$ref};
               $$refp{zak}=$$ref_zak{zak};
               $$refp{kmint}=undef;
               $$refp{kmstr}=$$ref{prejstr};
               $$refp{odoper}=$$ref{dooper}.".1"; # doplnenim desetineho mista zajistujes, ze operace je vetsi nez ta dooper a to jak pri textovem tak pri numerickem porovnavani
               $$refp{dooper}=$$ref{dooper}.".1";
               $$refp{dodstr}=$$ref{kmstr};
               $$refp{prejstr}=undef;
               $$refp{dav}=0;
               $$refp{pd}=0;
               $$refp{proczm}=0;
               $$refp{ekdav}=0;
               $$refp{umely}=1;
               push(@{$normativyp},$refp);
            }
         }
         $sth->finish;
         #= prejstr na poslednim kmint bylo rv a nedoslo k "oprave" vlozenych udaju - proved opravu nyni
         my $ref=${$normativyp}[-1];
         if(!defined($$ref{kmint})) {
            $$ref{kmint}="999";
            $$ref{odoper}="999";
            $$ref{dooper}="999";
         }
         #= pokud prejstr je stredisko hv, tak zde vytvorim dalsi umely kmint
         my $ref=${$normativyp}[-1];
         if(grep(/^\Q$$ref{prejstr}\E$/,@str_hv)) {
            my $refp;
            %{$refp}=%{$ref};
            $$refp{zak}=$$ref_zak{zak};
            $$refp{kmint}="999";
            $$refp{kmstr}=$$ref{prejstr};
            $$refp{odoper}="999";
            $$refp{dooper}="999";
            $$refp{dodstr}=$$ref{kmstr};
            $$refp{prejstr}=undef;
            $$refp{dav}=0; # mozna by slo prevzit nejak davku, ale stejne muze dodavat na jina (treba montazni) strediska i do jinych zak a tam je to davkovano jinak...
            $$refp{pd}=0;
            $$refp{proczm}=0;
            $$refp{ekdav}=0;
            $$refp{umely}=1;
            push(@{$normativyp},$refp);
         }
         #= zaverecna cistka dodstr a prejstr u krajnich kmint - jde o udaje, ktere nemusely byt pruchodem normativy ovlivneny - obecne se totiz neda rici kdo dodava na prvni kmint a ani kam je odvadeno z posledniho kmint - cistka je zde spravne umistena pred pripadne doplneny kmint prijmu hotovych soucasti z jinych org na sklad rv
         my $ref=${$normativyp}[0];
         $$ref{dodstr}=undef;
         my $ref=${$normativyp}[-1];
         $$ref{prejstr}=undef;
      }
   }
   #= kmint prijmu hotovych soucasti z jinych org na sklad rv
   elsif(defined($str_rv[0])) {
      my $refp;
      $$refp{zak}=$$ref_zak{zak};
      $$refp{kmint}="999";
      $$refp{kmstr}=$str_rv[0];
      $$refp{odoper}="999";
      $$refp{dooper}="999";
      $$refp{dodstr}=$pkg->dodstr_jinakmorg($ref_zak);
      $$refp{prejstr}=undef;
      $$refp{dav}=0; # mozna by slo prevzit nejak davku, ale stejne muze dodavat na jina (treba montazni) strediska i do jinych zak a tam je to davkovano jinak...
      $$refp{pd}=0;
      $$refp{proczm}=0;
      $$refp{ekdav}=0;
      $$refp{umely}=1;
      push(@{$normativyp},$refp);
   }
   #= pokud existuje omezeni na vysku kmint, je vyssi kmint nutne odstranit
   my $normativy;
   if(defined($dokmint)) {
      foreach my $ref (@{$normativyp}) {
         if($$ref{kmint} lt $dokmint or ($$ref{kmint} eq $dokmint and $$ref{kmstr} ne $dostr and defined($dostr))) {
            push(@{$normativy},$ref);
         }
         else {
            last;
         }
      }
   }
   else {
      $normativy=$normativyp;
   }
   return $normativy;
}


#== vraci v hashi radek "pocitacoveho" normativu, dle zadaneho cisla kmint a str
# je to v nekterych pripadech nahrada za fci Info->normativy,
# pozor prvni parametr neni zak ale $ref_zak
# pozor narozdil od Info->normativy, bude fce pekne pomala!!!
sub normativypoc {
   my ($pkg_p, $ref_zak,$kmint,$str)=@_;
   my $ref;
   my $normativy=$pkg->normativy($ref_zak);
   foreach my $ref_norm (@{$normativy}) {
      if($$ref_norm{kmint} eq $kmint) {
         $ref=$ref_norm;
         if($$ref_norm{kmstr} eq $str) {
            last;
         }
      }
   }
   return $ref;
}


#============================
#- funkce urcujici dodstr (stredisko, ktere zakazku odvadi (tedy dodava) na zadany kmint)
sub dodstr {
   my ($pkg_p, $ref_zak,$kmint,$str)=@_; # poznamka parametr $str je (asi) vzdy totozny s kmstr zadaneho kmint, ale abych ho zbytecne nezjistoval, kdyz ho uz pri volani fce vim (asi vzdycky), tak ho zde zadavam
   my $dodstr;
   my $normativy=$pkg->normativy($ref_zak);
   foreach my $ref (@{$normativy}) {
      if($$ref{kmint} gt $kmint) {
         last;
      }
      if($$ref{kmint} eq $kmint) {
         $dodstr=$$ref{dodstr};
         if($$ref{kmstr} eq $str) {
            last;
         }
      }
   }
   if(!defined($dodstr)) { # dodstr neni definovano - jde temer jiste o kmint na ktery se dodava material ze zasobovani - tos mrkam, kdo ho dodava
      ($dodstr)=$pkg->dodstr_mat($$ref_zak{zak},"000");
   }
   return $dodstr;
}

#- funkce urcujici prejstr (stredisko, ktere zakazku dostane (tedy prejima) ze zadaneho kmint)
sub prejstr {
   my ($pkg_p, $ref_zak,$kmint,$str)=@_;
   my $prejstr;
   my $normativy=$pkg->normativy($ref_zak);
   foreach my $ref (@{$normativy}) {
      if($$ref{kmint} gt $kmint) {
         last;
      }
      if($$ref{kmint} eq $kmint) {
         $prejstr=$$ref{prejstr};
         if($$ref{kmstr} eq $str) {
            last;
         }
      }
   }
   return $prejstr;
}

#- fce vraci stredisko, ktere dodava zakazku z jine org
sub dodstr_jinakmorg {
   my ($pkg_p, $ref_zak)=@_;
   my $dodstr;
   my $Eorg=get_env("org");
   set_env("org",$$ref_zak{kmorg});
   my $info_normativ=Info->normativy($$ref_zak{zak},"999",{krok=>-1});
   my $info_prejstr=Info->str($$info_normativ{prejstr});
   if($$info_prejstr{org} eq get_env("org")) {
      $dodstr=$$info_normativ{prejstr};
   }
   else {
      $dodstr=$$info_normativ{kmstr};
   }
   set_env("org",$Eorg);
   return $dodstr;
}

#- fce vraci stredisko, ktere dodava vstupni material na zak a informace o tomto materialu
sub dodstr_mat {
   my ($pkg_p, $zak)=@_;
   # udaje z materialove normy (predpokladam material na operaci 000)
   my $mat_info=$pkg->mat_info($zak);
   my $strodv;
   if(defined($mat_info)) {
      # strodv
      my $sklad_info=Info->sklad($$mat_info{sklad}); # pozn: tam zatim neni datum plat
      $strodv=$$sklad_info{supstr};
   }
   return ($strodv,$mat_info);
}

#- fce vraci informace o vstupnim materialu
sub mat_info {
   my ($pkg_p, $zak)=@_;
   # nahlednuti do materialove normy, pro dalsi udaje a zjisteni zda existuje vstupni material
   my $sth_matnor=$dbh->prepare(q{
      select
         Material_norma.mat,
         Material_norma.mj,
         Material_norma.mnoz
      from
         Vyroba_priprava.Material_norma
      where
         Material_norma.org=? and
         Material_norma.zak=? and
         Material_norma.oper=? and
         Material_norma.platod<=? and
         Material_norma.platdo>=? and
         Material_norma.ind in("0","1")
   });
   # udaje z materialove normy (predpokladam material na operaci 000)
   $sth_matnor->execute(get_env("org"),$zak,"000",get_env("datum"),get_env("datum"));
   my $mat_info=$sth_matnor->fetchrow_hashref;
   $sth_matnor->finish;
   if($sth_matnor->rows>0) {
      # nahlednuti do ciselniku materialu pro zjisteni z jakeho skladu se bude material vydavat
      my $sth_mat=$dbh->prepare(q{
         select
            Material.sklad,
            Material.mj
         from
            Material.Material
         where
            Material.mat=? and
            Material.platod<=? and
            Material.platdo>=?
      });
      # udaje z materialu
      $sth_mat->execute($$mat_info{mat},get_env("datum"),get_env("datum"));
      my $ref_mat=$sth_mat->fetchrow_hashref;
      $sth_mat->finish;
      $$mat_info{sklad}=$$ref_mat{sklad};
      $$mat_info{mjsklad}=$$ref_mat{mj};
   }
   else {
      $mat_info=undef;
   }
   return $mat_info;
}

return 1;

